### Application definitions ###
defApplication("MOS_oml","MOS_oml"){ |app|
	app.path = "/share/upload/benchmarking/oml_bin/MOS"

	app.shortDescription = 'Mean Opinion Score calculator for RTP audio stream'

	app.defProperty('omlClientID', 'Set the OML client’s identity','--oml-id', {:type => :string, :dynamic => false})
	app.defProperty('omlExprID', 'Set the OML client’s experimental identity','--oml-exp-id', {:type => :string, :dynamic => false})
	app.defProperty('omlFileName', 'Write measurements to a file','--oml-file', {:type => :string, :dynamic => false})
	app.defProperty('omlServerURI', 'Send measurements to the OML server specified by the uri','--oml-server', {:type => :string, :dynamic => false})

	app.defProperty('traceURI', 'trace format type (default: pcapint:wlan0)','-f', {:type => :string, :dynamic => false})
	app.defProperty('RTPPort', 'RTP port of the incoming audio (default: 5004)','-p', {:type => :integer, :dynamic => false})
	app.defProperty('samplFreq', 'Sampling frequency for the incoming audio (default: 8000 bps)','-s', {:type => :integer, :dynamic => false})
	app.defProperty('deviceID', 'listner node ID (default: 1)','-i', {:type => :integer, :dynamic => false})

	app.defMeasurement("quality"){ |mp|
		mp.defMetric('sourceID',	:uint32, 'source identifier')
		mp.defMetric('deviceID',	:uint32, 'device identifier')
		mp.defMetric('ts',	:double, 'timestamp')
		mp.defMetric('MOS',	:double, 'Mean Opinion Score')
	}
}
#### Property definitions ####
# Start input definition	
defProperty('speaker_wlan0_mode','master','')	
defProperty('speaker_wlan0_type','g','')	
defProperty('speaker_wlan0_channel','1','')	
defProperty('speaker_wlan0_essid','audioQltyExp_AP','')	
defProperty('speaker_wlan0_tx_power','20','')	
defProperty('speaker_wlan0_ip','192.168.10.10','')	
# End input definition	

# Start input definition	
defProperty('listner1_MOS_deviceID',1,'')	
defProperty('listner1_wlan0_mode','managed','')	
defProperty('listner1_wlan0_type','g','')	
defProperty('listner1_wlan0_channel','1','')	
defProperty('listner1_wlan0_essid','audioQltyExp_AP','')	
defProperty('listner1_wlan0_tx_power','20','')	
defProperty('listner1_wlan0_ip','192.168.10.1','')	
# End input definition	

# Start input definition	
defProperty('listner2_MOS_deviceID',2,'')	
defProperty('listner2_wlan0_mode','managed','')	
defProperty('listner2_wlan0_type','g','')	
defProperty('listner2_wlan0_channel','1','')	
defProperty('listner2_wlan0_essid','audioQltyExp_AP','')	
defProperty('listner2_wlan0_tx_power','20','')	
defProperty('listner2_wlan0_ip','192.168.10.2','')	
# End input definition	

# Start input definition	
defProperty('INT_SRV_wlan0_mode','master','')	
defProperty('INT_SRV_wlan0_type','g','')	
defProperty('INT_SRV_wlan0_channel','1','')	
defProperty('INT_SRV_wlan0_essid','INT_A_AP','')	
defProperty('INT_SRV_wlan0_tx_power','20','')	
defProperty('INT_SRV_wlan0_ip','192.168.20.10','')	
defProperty('INT_SRV_wlan1_mode','master','')	
defProperty('INT_SRV_wlan1_type','g','')	
defProperty('INT_SRV_wlan1_channel','13','')	
defProperty('INT_SRV_wlan1_essid','INT_B_AP','')	
defProperty('INT_SRV_wlan1_tx_power','20','')	
defProperty('INT_SRV_wlan1_ip','192.168.30.10','')	
# End input definition	

# Start input definition	
defProperty('INT_CLT_A_wlan0_mode','managed','')	
defProperty('INT_CLT_A_wlan0_type','g','')	
defProperty('INT_CLT_A_wlan0_channel','1','')	
defProperty('INT_CLT_A_wlan0_essid','INT_A_AP','')	
defProperty('INT_CLT_A_wlan0_tx_power','20','')	
defProperty('INT_CLT_A_wlan0_ip','192.168.20.1','')	
# End input definition	

# Start input definition	
defProperty('INT_CLT_B_wlan0_mode','managed','')	
defProperty('INT_CLT_B_wlan0_type','g','')	
defProperty('INT_CLT_B_wlan0_channel','13','')	
defProperty('INT_CLT_B_wlan0_essid','INT_B_AP','')	
defProperty('INT_CLT_B_wlan0_tx_power','20','')	
defProperty('INT_CLT_B_wlan0_ip','192.168.30.1','')	
# End input definition	

#### Group definitions ####
defGroup('speaker', ['nodef5.audioqltyexpoptsumo.benchmarking.wilab2.ilabt.iminds.be']) {|node|	
	node.net.w0.mode = property.speaker_wlan0_mode	
	node.net.w0.type = property.speaker_wlan0_type	
	node.net.w0.channel = property.speaker_wlan0_channel	
	node.net.w0.essid = property.speaker_wlan0_essid	
	node.net.w0.tx_power = property.speaker_wlan0_tx_power	
	node.net.w0.ip = property.speaker_wlan0_ip	

}	
defGroup('listner1', ['nodeg4.audioqltyexpoptsumo.benchmarking.wilab2.ilabt.iminds.be']) {|node|	
	node.addApplication('MOS_oml',{:id => 'MOS'}) {|MOS|	
		MOS.setProperty('deviceID', property.listner1_MOS_deviceID)	
		MOS.setProperty('omlClientID', 'listner1_MOS')	
		MOS.setProperty('omlExprID', Experiment.ID)	
		MOS.setProperty('omlServerURI', 'tcp:10.11.31.5:3004')	
	}	

=begin propertyDef	
<Group name='listner1'>	
	<App name='MOS_oml' id='MOS'>	
		<MP name='quality'>	
			<metric name='sourceID' type='uint32' unit='' />	
			<metric name='deviceID' type='uint64' unit='' />	
			<metric name='ts' type='double' unit='UNIX_sec' />	
			<metric name='MOS' type='double' unit='' />	
		</MP>	
	</App>	
</Group>	
=end	

	node.net.w0.mode = property.listner1_wlan0_mode	
	node.net.w0.type = property.listner1_wlan0_type	
	node.net.w0.channel = property.listner1_wlan0_channel	
	node.net.w0.essid = property.listner1_wlan0_essid	
	node.net.w0.tx_power = property.listner1_wlan0_tx_power	
	node.net.w0.ip = property.listner1_wlan0_ip	

}	
defGroup('listner2', ['nodeg6.audioqltyexpoptsumo.benchmarking.wilab2.ilabt.iminds.be']) {|node|	
	node.addApplication('MOS_oml',{:id => 'MOS'}) {|MOS|	
		MOS.setProperty('deviceID', property.listner2_MOS_deviceID)	
		MOS.setProperty('omlClientID', 'listner2_MOS')	
		MOS.setProperty('omlExprID', Experiment.ID)	
		MOS.setProperty('omlServerURI', 'tcp:10.11.31.5:3004')	
	}	

=begin propertyDef	
<Group name='listner2'>	
	<App name='MOS_oml' id='MOS'>	
		<MP name='quality'>	
			<metric name='sourceID' type='uint32' unit='' />	
			<metric name='deviceID' type='uint64' unit='' />	
			<metric name='ts' type='double' unit='UNIX_sec' />	
			<metric name='MOS' type='double' unit='' />	
		</MP>	
	</App>	
</Group>	
=end	

	node.net.w0.mode = property.listner2_wlan0_mode	
	node.net.w0.type = property.listner2_wlan0_type	
	node.net.w0.channel = property.listner2_wlan0_channel	
	node.net.w0.essid = property.listner2_wlan0_essid	
	node.net.w0.tx_power = property.listner2_wlan0_tx_power	
	node.net.w0.ip = property.listner2_wlan0_ip	

}	
defGroup('INT_SRV', ['nodeh5.audioqltyexpoptsumo.benchmarking.wilab2.ilabt.iminds.be']) {|node|	
	node.net.w0.mode = property.INT_SRV_wlan0_mode	
	node.net.w0.type = property.INT_SRV_wlan0_type	
	node.net.w0.channel = property.INT_SRV_wlan0_channel	
	node.net.w0.essid = property.INT_SRV_wlan0_essid	
	node.net.w0.tx_power = property.INT_SRV_wlan0_tx_power	
	node.net.w0.ip = property.INT_SRV_wlan0_ip	

	node.net.w1.mode = property.INT_SRV_wlan1_mode	
	node.net.w1.type = property.INT_SRV_wlan1_type	
	node.net.w1.channel = property.INT_SRV_wlan1_channel	
	node.net.w1.essid = property.INT_SRV_wlan1_essid	
	node.net.w1.tx_power = property.INT_SRV_wlan1_tx_power	
	node.net.w1.ip = property.INT_SRV_wlan1_ip	

}	
defGroup('INT_CLT_A', ['nodei4.audioqltyexpoptsumo.benchmarking.wilab2.ilabt.iminds.be']) {|node|	
	node.net.w0.mode = property.INT_CLT_A_wlan0_mode	
	node.net.w0.type = property.INT_CLT_A_wlan0_type	
	node.net.w0.channel = property.INT_CLT_A_wlan0_channel	
	node.net.w0.essid = property.INT_CLT_A_wlan0_essid	
	node.net.w0.tx_power = property.INT_CLT_A_wlan0_tx_power	
	node.net.w0.ip = property.INT_CLT_A_wlan0_ip	

}	
defGroup('INT_CLT_B', ['nodei6.audioqltyexpoptsumo.benchmarking.wilab2.ilabt.iminds.be']) {|node|	
	node.net.w0.mode = property.INT_CLT_B_wlan0_mode	
	node.net.w0.type = property.INT_CLT_B_wlan0_type	
	node.net.w0.channel = property.INT_CLT_B_wlan0_channel	
	node.net.w0.essid = property.INT_CLT_B_wlan0_essid	
	node.net.w0.tx_power = property.INT_CLT_B_wlan0_tx_power	
	node.net.w0.ip = property.INT_CLT_B_wlan0_ip	

}	
#### Applications timeline definition ####
onEvent(:ALL_UP_AND_INSTALLED) {|event|	

	group('listner1').exec('iwconfig wlan0 essid audioQltyExp_AP')
	group('listner2').exec('iwconfig wlan0 essid audioQltyExp_AP')
	group('INT_CLT_A').exec('iwconfig wlan0 essid INT_A_AP')
	group('INT_CLT_B').exec('iwconfig wlan0 essid INT_B_AP')

	wait 4	
	group('speaker').exec('/share/upload/benchmarking/ptpd -b eth0 -h 1 -t 1 -i 5 -D 1 -f /var/log/ptpd.log')	
	wait 1	
	group('listner2').startApplication('MOS')	
	group('INT_SRV').exec('route add -net 192.168.30.0/24 dev wlan1')	
	group('INT_SRV').exec('route add -net 192.168.20.0/24 dev wlan0')	
	group('listner1').startApplication('MOS')	
	group('listner2').exec('/share/upload/benchmarking/ptpd -b eth0 -h 1 -g 1 -i 5 -D 1 -f /var/log/ptpd.log')	
	group('listner1').exec('/share/upload/benchmarking/ptpd -b eth0 -h 1 -g 1 -i 5 -D 1 -f /var/log/ptpd.log')	
	wait 1	
	group('speaker').exec('route add -net 235.0.0.0/8 dev wlan0')	
	group('speaker').exec('su - mmehari -c "cvlc /share/upload/benchmarking/audio_10sec.mp3 --sout \"#transcode{vcodec=none,acodec=alaw,channels=1,samplerate=8000}:rtp{dst=235.5.5.5 port=5004,l=1}\""')	
	group('INT_SRV').exec('iperf -B 192.168.20.10 -c 192.168.20.1 -t 10 -u -b 10M')	
	group('INT_SRV').exec('iperf -B 192.168.30.10 -c 192.168.30.1 -t 10 -u -b 10M')	
	wait 10	
	group('listner2').stopApplication('MOS')	
	group('listner1').stopApplication('MOS')	
	group('speaker').exec('killall vlc')	
	group('INT_SRV').exec('killall iperf')	
}	

defEvent(:APP_COMPLETED)  {|event|	
	app_status = allGroups.state('apps/app/status/@value')	
	info "Status of Apps:  #{app_status.inspect}"	
	event.fire if !app_status.nil? && allEqual(app_status, 'DONE.OK')	
}	

onEvent(:APP_COMPLETED) {|event|	
	info 'All applications are stopped now...'	
	Experiment.done	
}	

=begin propertyUpdate
<parOpt type='SUMO'><dsgnSpacePar><par name='speaker_wlan0_channel' from='1' to='13' /><par name='speaker_wlan0_tx_power' from='1' to='20' /></dsgnSpacePar><objVar><var name='x1' type ='DB' group='listner1' table='MOS_oml_quality' id='MOS' metric='MOS' unit='' aggr='SUM' /><var name='x2' type ='DB' group='listner1' table='MOS_oml_quality' id='MOS' metric='MOS' unit='' aggr='COUNT' /><var name='x3' type ='DB' group='listner2' table='MOS_oml_quality' id='MOS' metric='MOS' unit='' aggr='SUM' /><var name='x4' type ='DB' group='listner2' table='MOS_oml_quality' id='MOS' metric='MOS' unit='' aggr='COUNT' /><var name='x5' type ='DSP' DSP_Name='speaker_wlan0_tx_power' /></objVar><objFx string='((x1+x3+(162-x2-x4)*1)/162-1)/4-(x5-1)/19' /><optContx type='max' /><stopCrtr type='STDLT' value='0.05' /><initialSampling size='5' type='LHS' /><SUMO_credential hostName='nodei4.audioqltyexpoptsumo.benchmarking.wilab2.ilabt.iminds.be' userName='username' password='password' /></parOpt><perVis><var group='listner1' table='MOS_oml_quality' id='MOS' metric='MOS' unit='' /><var group='listner2' table='MOS_oml_quality' id='MOS' metric='MOS' unit='' /></perVis><intEst prePostEst='false' scanMethod='undefined' centerFreq='undefined' /><rounds value='1' />
=end
